Option Explicit

#include local-parameters.inc
#include ..\lib\framework_domotics.vbs

Sub main
Dim astrDevices
Dim astrConfig
Dim atabDv
Dim astrNbDv
Dim i
Dim astrDevice
Dim astrNetworkAddress
Dim astrStatus
Dim astrREBOOT_TEMPO
Dim astrREBOOT_DEVICE
Dim astrREBOOT_LASTONE
Dim aintNbINF
Dim aintNbCRI
Dim aintNbSEV
Dim aintAllINF
Dim aintAllCRI
Dim aintAllSEV
Dim adateBuffer
Dim astrLevel

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching " & G_FOLDER_NAME & " script", G_LOG_FILE
If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
	astrDevices 		   = hs.GetINISetting("COMMON","MACHINES","", G_FILE_INI)
	astrConfig  		   = hs.GetINISetting("COMMON","CONFIG","..\scripts\config\", G_FILE_INI)
	astrREBOOT_TEMPO	 = hs.GetINISetting("COMMON","REBOOT_TEMPO","..\scripts\config\", G_FILE_INI)
	astrREBOOT_DEVICE	 = hs.GetINISetting("COMMON","REBOOT_DEVICE","..\scripts\config\", G_FILE_INI)	
	astrREBOOT_LASTONE = hs.GetINISetting("COMMON","REBOOT_LASTONE","..\scripts\config\", G_FILE_INI)	
	atabDv	 			     = Split(astrDevices, G_SEP)
	astrNbDv 			     = UBound(atabDv) 
	i            = 0
	aintNbINF    = 0
	aintNbCRI    = 0 
	aintNbSEV    = 0
	aintAllINF   = 0
	aintAllCRI   = 0 
	aintAllSEV   = 0
	While (i <= Cint(astrNbDv))
		astrDevice 				= hs.GetINISetting("DEVICE", "HC", "", astrConfig & atabDv(i)) & _ 
									       hs.GetINISetting("DEVICE", "DC", "", astrConfig & atabDv(i))
		astrNetworkAddress= hs.GetINISetting("DEVICE","PARAM1","",astrConfig & atabDv(i))
		astrLEVEL				  = hs.GetINISetting("DEVICE","PARAM2","",astrConfig & atabDv(i))
		
  	If (UCase(astrLEVEL) = G_TIV_SEV) Then
  	   aintAllSEV = aintAllSEV + 1
    Elseif (UCase(astrLEVEL) = G_TIV_CRI) Then
  	   aintAllCRI = aintAllCRI + 1
		Else
  	   aintAllINF = aintAllINF + 1
		End if
		
		astrStatus 			= doPing(astrNetworkAddress)
		
		If (UCase(astrStatus) = UCase("Not Available")) and (UCase(hs.DeviceString(astrDevice)) = UCase("Available")) Then		
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, astrDevice & _
               " (i.e. " & astrNetworkAddress & ") is down", G_LOG_FILE	
		End If
		
		If (UCase(astrStatus) = UCase("Available")) and (UCase(hs.DeviceString(astrDevice)) = UCase("Not Available")) Then
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, astrDevice & _
               " (i.e. " & astrNetworkAddress & ") is up", G_LOG_FILE	
		End If
		
		If (UCase(astrStatus) <> UCase("Available")) Then
		  	If (UCase(astrLEVEL) = G_TIV_SEV) Then
    	     aintNbSEV = aintNbSEV + 1
        Elseif (UCase(astrLEVEL) = G_TIV_CRI) Then
  	       aintNbCRI = aintNbCRI + 1
		    Else
  	       aintNbINF = aintNbINF + 1
		    End if
		End if
		
		SetDevice astrDevice, astrStatus, "", ""
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Pinging " & astrNetworkAddress & " => " & astrStatus, G_LOG_FILE
		i=i+1
	Wend
	
	If ((aintNbCRI = aintAllCRI) and (aintNbCRI > 0)) or (aintNbSEV > 0) Then
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "All external links are broken ! ", G_LOG_FILE	

		If (astrREBOOT_DEVICE <> "") and (hs.DeviceExists(astrREBOOT_DEVICE) <> -1) Then
			If (astrREBOOT_LASTONE <> "") and (hs.DeviceExists(astrREBOOT_LASTONE) <> -1) Then			
				If Abs(DateDiff("N", hs.DeviceLastChange(astrREBOOT_LASTONE), Now) >= 10) Then
					WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Trying to reboot ...", G_LOG_FILE
					SetDevice astrREBOOT_LASTONE, "Trying Reboot", "", ""
          			hs.SetDeviceLastChange astrREBOOT_LASTONE, now					
					SetDevice astrREBOOT_DEVICE, "", G_STATUS_OFF, ""
					hs.WaitSecs 10
					SetDevice astrREBOOT_DEVICE , "", G_STATUS_ON,  ""
					SetDevice astrREBOOT_LASTONE, "Rebooted", "", ""
					hs.SetDeviceLastChange astrREBOOT_LASTONE, now
				End if
			Else
				WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrREBOOT_LASTONE & " is unknown, reboot is impossible ...", G_LOG_FILE			
			End If
		Else
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrREBOOT_DEVICE & " is unknown, reboot is impossible ...", G_LOG_FILE			
		End if
	End If
	

Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE 
End if

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE 
End sub
